library metaphon;

{Metaphone algorithm translated by Tom White <wcs@intellex.com>

v1.1 fixes a few bugs

    Checks length of string before removing trailing S (>1)
    PH used to translate to H, now translates to F

v1.2

    The pairs at the beginning of the word were not being caught.

v1.3

    Fixes bugs created because I don't have a version control system

v1.4

    Added PS to S at beginning of word for Dave Green
    Tracking length of input string much better now so it always checks
      the correct number of letters
    The method I was using to check the first two letters of the word
      did *not* work very well.

Original C version by Michael Kuhn <rhlab!mkuhn@uunet.uu.net>

}

uses sysutils, windows, dialogs;  {Uncomment this and the showmessage below
                                     for debugging}
{a=pointer to input string
 lg=max length of return string
 res=pointer to buffer to place result string in - must be lg+1 bytes long}

{type

pMeta=^meta;
meta=record
  a : array [0..29] of char;
  lg : integer;
  res : array[0..29] of char;
end;}

procedure metaphone(a : pchar; lg : integer;res : pchar); stdcall;
var
  b, c : string;
  inp, outp : string;
  vowels, frontv, varson, dbl : string;
  excppair, nxtltr : string;
  t, ii, slength : integer;
  curltr, prevltr, nextltr, nextltr2, nextltr3 : char;
  vowelafter, vowelbefore, frontvafter, silent, hard : boolean;
  alphachr : string;
begin
  inp:=uppercase(a);
  slength:=length(inp);
//  showmessage(inp+' '+inttostr(lg));
  vowels:='AEIOU';
  frontv:='EIY';
  varson:='CSPTG';
  dbl:='.';  {Lets us allow certain letters to be doubled}
  excppair:='AGKPWP'; //added PS 6/2/98 for Dave Green
  nxtltr:='ENNNRS';
  alphachr:='ABCDEFGHIJKLMNOPQRSTUVWXYZ';

  {Remove non-alpha characters}
  outp:='';
  for t:=1 to lg do
    if pos(inp[t],alphachr)>0 then outp:=outp+inp[t];

  inp:=outp;
  outp:='';

  if lg=0 then begin  {lg=0}
    res:='';
//    showmessage('Aborting because of short string.');
//    strcopy(res,chr(0));
    exit;
  end;

  {Check rules at beginning of word}
  if lg>1 then begin  //completely changed 6/2/98, old method was *bad*
    b:=inp[1];
    c:=inp[2];
    for t:= 1 to length(excppair) do
      if (b=excppair[t]) and (c=nxtltr[t]) then begin
        inp:=copy(inp,2,lg-1);
        dec(slength);
        break;
      end;
  end;

  if inp[1]='X' then inp[1]:='S';

  if (lg>2) and (copy(inp,1,2)='WH') then
    inp:='W'+copy(inp,3,lg-2);

  if (lg>1) and (inp[lg]='S') then
    inp:=copy(inp,1,lg-1);

  ii:=0;
  repeat
    ii:=ii+1;
    {Main Loop!}

    hard:=false;
    curltr:=inp[ii];
    vowelbefore:=false;
    prevltr:=' ';

    if ii>1 then begin
      prevltr:=inp[ii-1];
      if pos(prevltr,vowels)>0 then
        vowelbefore:=true;
    end;

    if ((ii=1) and (pos(curltr,vowels)>0)) then begin
      outp:=outp+curltr;
      continue;
    end;

    vowelafter:=false;
    frontvafter:=false;
    nextltr:=' ';
    if ii<lg then begin
      nextltr:=inp[ii+1];
      if pos(nextltr,vowels)>0 then vowelafter:=true;
      if pos(nextltr,frontv)>0 then frontvafter:=true;
    end;

    {Skip double letters EXCEPT ones in variable double}
    if pos(curltr,dbl)=0 then
      if curltr=nextltr then
        continue;

    nextltr2:=' ';
    if (lg-ii)>1 then
      nextltr2:=inp[ii+2];

    nextltr3:=' ';
    if (lg-ii)>2 then
      nextltr3:=inp[ii+3];

    case curltr of

      'B' : begin
              silent:=false;
              if (ii=lg) and (prevltr='M') then
                silent:=true;
              if not silent then outp:=outp+curltr;
            end;

      'C' : begin
              if not ((ii>2) and (prevltr='S') and frontvafter) then
                if ((ii>1) and (nextltr='I') and (nextltr2='A')) then
                  outp:=outp+'X'
                else
                  if frontvafter then begin
                    outp:=outp+'S';
                  end else begin
                    if ((ii>2) and (prevltr='S') and (nextltr='H')) then begin
                      outp:=outp+'K';
                    end else begin
                      if nextltr='H' then begin
                        if ((ii=1) and (pos(nextltr2,vowels)=0)) then
                          outp:=outp+'K'
                        else
                          outp:=outp+'X';
                      end else begin
                        if prevltr='C' then
                          outp:=outp+'C'
                        else
                          outp:=outp+'K';
                      end;
                    end;
                  end;
              end;

      'D' : begin
              if ((nextltr='G') and (pos(nextltr2,frontv)>0)) then
                outp:=outp+'J'
              else
                outp:=outp+'T';
            end;

      'G' : begin
              silent:=false;
              if ((ii<lg) and (nextltr='H') and (pos(nextltr2,vowels)=0)) then
                silent:=true;
              if ((ii=lg-4) and (nextltr='N') and (nextltr2='E') and
                (nextltr3='D')) then silent:=true
              else if ((ii=lg-2) and (nextltr='N')) then silent:=true;
              if (prevltr='D') and frontvafter then silent:=true;
              if prevltr='G' then
                hard:=true;

              if not silent then begin
                if frontvafter and (not hard) then
                  outp:=outp+'J'
                else
                  outp:=outp+'K';
              end;

            end;

      'H' : begin
              silent:=false;
              if pos(prevltr,varson)>0 then silent:=true;
              if vowelbefore and (not vowelafter) then silent:=true;

              if not silent then outp:=outp+curltr;
            end;


      'F', 'J', 'L', 'M', 'N', 'R' : outp:=outp+curltr;

      'K' : if prevltr<>'C' then outp:=outp+curltr;

      'P' : if nextltr='H' then outp:=outp+'F' else outp:=outp+'P';

      'Q' : outp:=outp+'K';

      'S' : begin
              if ((ii>2) and (nextltr='I') and ((nextltr2='O') or (nextltr2='A'))) then
                outp:=outp+'X';
              if (nextltr='H') then
                outp:=outp+'X'
              else
                outp:=outp+'S';
            end;

      'T' : begin
              if ((ii>0) and (nextltr='I') and ((nextltr2='O') or (nextltr2='A'))) then
                outp:=outp+'X';
              if nextltr='H' then begin
                if ((ii>1) or (pos(nextltr2,vowels)>0)) then
                  outp:=outp+'0'
                else
                  outp:=outp+'T';
              end else
                if not ((ii<lg-3) and (nextltr='C') and (nextltr2='H')) then
                  outp:=outp+'T';
            end;

      'V' : outp:=outp+'F';

      'W', 'Y' : if (ii<lg-1) and vowelafter then outp:=outp+curltr;

      'X' : outp:=outp+'KS';

      'Z' : outp:=outp+'S';

    end;

  until (length(outp)>=lg) or (ii>=slength); //added slength 6/2/98

  strcopy(res,@outp[1]);
{  res:=outp;}
{  showmessage('Returning: '+outp);}
{  showmessage('Memory: '+res);}
end;

exports
  metaphone index 1 name 'metaph';

end.
