unit Metaphon;

interface

uses
  classes, dialogs, mtph2;

type
  TMetaphone = class(TComponent)
  private
    { Private declarations }
    LengthVar: Integer;
    outstr: string;
    instr: string;
    procedure SetLength(Len: Integer);
    procedure setinstr(x : string);
    procedure setoutstr(x : string);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure metaphone(a : String; lg : integer; var res : String);
    procedure Execute;
  published
    { Published declarations }
    property OutLength: Integer read LengthVar write SetLength default 20;
    property outstring: string read outstr write setoutstr;
    property instring: string read instr write setinstr;
  end;

procedure Register;

implementation

constructor TMetaphone.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);	{ call the inherited constructor }
  LengthVar := 20;          { looks like a kinda nice value  }
  instr := '';
  outstr := '';
end;

procedure TMetaphone.Execute;
begin
  if (instr<>'') and (LengthVar > 0) then
    metaphone(instr, LengthVar,outstr)
  else
    outstr := '';
end;

procedure TMetaphone.SetLength(Len: Integer);
begin
  if (Len > 0) and (Len < 100) then
    LengthVar := Len;
end;

procedure TMetaphone.setinstr(x : string);
begin
  instr:=x;
end;

procedure TMetaphone.setoutstr(x : string);
begin
  outstr:=x;
end;

procedure TMetaphone.metaphone(a : String; lg : integer; var res : String);
var
  t: integer;
begin
  res:='';
  for t:=1 to lg do
    res:=res+' ';

  res:=mtph2.metaphone(pchar(a), lg);
  //reference unit mtph2, different from object reference
end;

procedure Register;
begin
  RegisterComponents('WCS', [TMetaphone]);
end;

end.
